// A client for subject/observer
procedure client()
    modifies $Heap;
    // user-declared postconditions
    // effects
  {   
        var sub0 : ref;
        var obs0 : ref;
        var obs1 : ref;
        var sub  : ref;
        var obs  : ref;

    // sub0 = new Subject();
        havoc sub0;
        assume !$Heap[sub0,alloc];
        call Subject..ctor(sub0);

    // obs0 = new Observer(sub0);
        havoc obs0;
        assume !$Heap[obs0,alloc];
        assume EqualSet($Heap[obs0, Subject.O],  EmptySet);
        call Observer..ctor(obs0, sub0);

    // obs1 = new Observer(sub0);
        havoc obs1;
        assume !$Heap[obs1,alloc];
        assume EqualSet($Heap[obs1, Subject.O],  EmptySet);
        call Observer..ctor(obs1, sub0);

  //   sub  = new Subject();
        havoc sub;
        assume !$Heap[sub,alloc];
        call Subject..ctor(sub);

   //  obs = new Observer(sub);
        havoc obs;
        assume !$Heap[obs,alloc];
        assume EqualSet($Heap[obs, Subject.O],  EmptySet);
        call Observer..ctor(obs, sub);

        call Subject.update(sub0, 5);

        assert DisjointSet($Heap[sub0, Subject.O], $Heap[sub, Subject.O]);

        assert SubObs(sub0, 5, $Heap);

        assert SubObs(sub, 0, $Heap);
  }
