procedure ArrayList.Client() returns ()
  modifies Heap;
{
  var a1: ref;
  var a2: ref;
  var i : int;
  var tmp: any;

  // a1 = new ArrayList();
    havoc a1;
    assume !Heap[a1,alloc];
    call ArrayList..ctor(a1);

  // a2 = new ArrayList();
    havoc a2;
    assume !Heap[a2,alloc];
    call ArrayList..ctor(a2);

  call ArrayList.Add(a1, 3);

  call tmp := ArrayList.Get(a1,0);
  i := cast(tmp,int);
  assert i == 3;

  call ArrayList.Add(a2,5);
  
  call tmp := ArrayList.Get(a1,0);
  i := cast(tmp,int);
  assert i == 3;

  call ArrayList.Add(a1, 5);

  call tmp := ArrayList.Get(a1,0);
  i := cast(tmp,int);
  assert i == 3;

  call tmp := ArrayList.Get(a1,1);
  i := cast(tmp,int);
  assert i == 5;

  call tmp := ArrayList.Get(a2,0);
  i := cast(tmp,int);
  assert i == 5;
}