//
// Axioms for client view of functions
//

// function Stack.INV(h: [ref, <x>name]x, o: ref) returns (bool);
// INV depends only on the things in its footprint
axiom
  (forall H: [ref, <x>name]x, K: [ref, <x>name]x, o: ref
    :: { Stack.INV(H,o), Stack.INV(K,o) }

      (
        IsGoodObject(o, H) && IsGoodObject(o,K)
        && H[o,Stack.footprint] == K[o,Stack.footprint]
        && (forall p : ref, f: name ::
             IsGoodObject(p,H) && IsGoodObject(p,K) && H[o,Stack.footprint][p] 
             ==>  H[p,f] == K[p,f])
      )
      ==>
      Stack.INV(H,o) == Stack.INV(K,o)
  );
  
axiom
  (forall H: [ref, <x>name]x, o: ref
    :: { Stack.INV(H,o) }

      Stack.INV(H,o)
      ==>
      (forall p: ref :: H[o,Stack.footprint][p] ==> IsGoodObject(p,H))
  );

// #Stack.size(h: [ref, <x>name]x, o: ref) returns (int);
axiom
  (forall H: [ref, <x>name]x, K: [ref, <x>name]x, o: ref
    :: { #Stack.size(H,o), #Stack.size(K,o) }

      (
        IsGoodObject(o, H) && IsGoodObject(o,K)
        && H[o,Stack.footprint] == K[o,Stack.footprint]
        && (forall p : ref, f: name ::
             IsGoodObject(p,H) && IsGoodObject(p,K) && H[o,Stack.footprint][p] 
             ==>  H[p,f] == K[p,f])
      )
      ==>
      #Stack.size(H,o) == #Stack.size(K,o)
  );

